/* Shoot or Die! - Game.h
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#ifndef _GAME_H_
#define _GAME_H_

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_mixer.h>
#include "VideoDriver.h"
#include "Graphics.h"
#include "Image.h"
#include "Sprite.h"
#include "Oblong.h"
#include "Tilemap.h"

// Game Class
class Game {

	const std::string TITLE;
	const std::string RELEASE;

	enum { SDL, OPENGL };
	int driver;

	VideoDriver* video;
	Graphics* screen;
	Image* background;
	Image* turricana;
	Sprite* player;
	Tilemap* map;
	//Image* message;

	SDL_Surface* message;

	TTF_Font* font;

	Mix_Chunk* sample;
	Mix_Music* music;

	Oblong clip;

	int width;
	int height;
	int bpp;

	SDL_Event event;

	SDL_Color textcolor;

	bool Create();
	bool Destroy();

	void Demo();

public:
	Game(std::string, std::string);
	~Game();
};

#endif // _GAME_H_
