/* Shoot or Die! - OpenGLDriver.h
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#ifndef _OPENGLDRIVER_H_
#define _OPENGLDRIVER_H_

#include <SDL/SDL.h>
#include "VideoDriver.h"

// OpenGL Driver class
class OpenGLDriver : public VideoDriver {

	const int WIDTH, HEIGHT, DEPTH;
	const std::string TITLE;

	bool fullscreen;

	SDL_Surface* screen;

	void SetVideoMode(int, int, int);
	void ResizeSurface(int, int);
	void InitOpenGL();

public:
	OpenGLDriver(int, int, int, std::string, bool);
	~OpenGLDriver();
	void Fullscreen();
	void ShowMouse(bool);
	void BeginDraw();
	void EndDraw();
};

#endif // _OPENDRIVER_H_
