/* Shoot or Die! - OpenGLImage.h
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#ifndef _OPENGLIMAGE_H_
#define _OPENGLIMAGE_H_

#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
#include "Image.h"

// OpenGL Image class
class OpenGLImage : public Image {

	GLuint texture_handle;
	GLint color_depth;
	GLenum texture_format;

	int texture_width, texture_height;
	int image_width, image_height;

	unsigned int* texture;

	SDL_Surface* SDLLoadImage(std::string, int);

public:
	OpenGLImage();
	~OpenGLImage();
	Image* LoadImage(std::string, int = 0x1000000);
	int Width();
	int Height();
	int TextureWidth();
	int TextureHeight();
	GLuint Texture();
};

#endif // _OPENGLIMAGE_H_
