/* Shoot or Die! - SDLDriver.h
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#ifndef _SDLDRIVER_H_
#define _SDLDRIVER_H_

#include <SDL/SDL.h>
#include "VideoDriver.h"

// SDL Driver class
class SDLDriver : public VideoDriver {

	const int WIDTH, HEIGHT, DEPTH;
	const std::string TITLE;

	bool fullscreen;

	SDL_Surface* screen;

	void SetVideoMode(int, int, int);

public:
	SDLDriver(int, int, int, std::string, bool);
	~SDLDriver();
	void Fullscreen();
	void ShowMouse(bool);
	void BeginDraw();
	void EndDraw();
};

#endif // _SDLDRIVER_H_
