/* Shoot or Die! - Sprite.h
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#ifndef _SPRITE_H_
#define _SPRITE_H_

#include "Image.h"
#include "Graphics.h"
#include "Oblong.h"

// Sprite Class
class Sprite {

	int xpos, ypos;
	int xvel, yvel;
	int frame;
	bool animated;
	int timer;

protected:
	Image* spritesheet;
	Graphics* graphics;
	int framerate;

public:
	Sprite(std::string = "\0", int = -1, int = -1);
	virtual ~Sprite() { delete spritesheet; delete graphics; };
	void SetPosition(int x, int y);
	int XVelocity(int = 0);
	int YVelocity(int = 0);
	void Move();
	void Draw(Image*, Oblong* = 0, int = -1, int = -1);
	bool Animate(bool = true);
};


#endif // _SPRITE_H_
