/* Shoot or Die! - Starfield.h
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#ifndef _STARFIELD_H_
#define _STARFIELD_H_

#include <vector>
#include "Graphics.h"

// concrete decorator
class Starfield {

	Graphics* graphics;

	const int WIDTH, HEIGHT, TOTAL_STARS;

	enum attributes { BLACK = 0x000000, WHITE = 0xffffff, SHADE = 0x010101, DISTANCE = 0xff, SCALE = 0xff };

	std::vector< std::vector<int> > stars;
	void DrawStars();

public:
	Starfield(Graphics*, int, int, int);
	~Starfield();
	void Draw();
};

#endif // _STARFIELD_H_
