/* Shoot or Die! - Tilemap.h
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#ifndef _TILEMAP_H_
#define _TILEMAP_H_

#include <vector>
#include "Image.h"
#include "Graphics.h"
#include "Oblong.h"

// Tilemap Class
class Tilemap {

	enum { CORNER = 0x000000, FRAME = 0xffffff };

	std::string mapfile;
	std::string engine;
	int version;
	std::string map_name;
	std::string map_description;
	int map_width, map_height;
	std::vector< std::vector<int> > tiles;
	Oblong clip;
	int tile_width, tile_height;
	int tiles_x, tiles_y;
	int total_width, total_height;
	int total_tiles;
	int camera_width, camera_height;		// camera size in tiles
	int screen_x, screen_y;
	int max_camera_x, max_camera_y;

protected:
	bool LoadMap(std::string = "\0");
	bool LoadTileset(std::string = "\0");
	std::string tilesetfile;
	Graphics* graphics;
	Image* tileset;

public:
	Tilemap(std::string = "\0");
	virtual ~Tilemap() { delete tileset; delete graphics; };
	void Draw(Image*, int, int);
	void SetCamera(int, int, int = NULL, int = NULL);
};

#endif // _TILEMAP_H_
