/* Shoot or Die! - SDLImage.cpp
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#include <SDL/SDL_image.h>
#include "SDLImage.h"

SDLImage::SDLImage() {}
SDLImage::~SDLImage() {}

Image* SDLImage::LoadImage(std::string filename, int colorkey) {


	// load image into temporary buffer
	SDL_Surface* tbuf = IMG_Load(filename.c_str());
	if (!tbuf) {
		std::cerr << "Couldn't load '" << filename << "': "
		          << SDL_GetError() << std::endl;
		exit(1);
	}

	// optimize image
	image = SDL_DisplayFormat(tbuf);
	SDL_FreeSurface(tbuf);

	// set image size
	width = image->w;
	height = image->h;

	// set colorkey
	if (colorkey < 0x1000000) {
		colorkey = SDL_MapRGB(image->format, colorkey, colorkey >> 8, colorkey >> 16);
		SDL_SetColorKey(image, SDL_SRCCOLORKEY, colorkey);
	}

	return this;
}

SDL_Surface* SDLImage::Surface() { return image; }

int SDLImage::Width() { return width; }
int SDLImage::Height() { return height; }
