/* Shoot or Die! - Starfield.cpp
 * Copyright (c) 2008, 2009 by Michael Borgmann <mail@lechuck.de>
 * This code is released under the ISC license
 */

#include <ctime>
#include <cstdlib>
#include "Starfield.h"

Starfield::Starfield(Graphics* gfx, int w, int h, int total) : graphics(gfx), WIDTH(w), HEIGHT(h), TOTAL_STARS(total) {

	// initialize random generator
	srand(time(0));

	// initialize stars
	for (int i = 0; i < TOTAL_STARS; i++) {
		stars.push_back(std::vector<int>(3));
		stars[i][0] = rand() % WIDTH - WIDTH / 2;
		stars[i][1] = rand() % HEIGHT - HEIGHT / 2;
		stars[i][2] = rand() % DISTANCE;
	}
}

Starfield::~Starfield() {}

void Starfield::Draw() {

	for (int i = 0; i < TOTAL_STARS; i++) {

		stars[i][2] -= 1;

		if (stars[i][2] <= 0) {
			stars[i][2] = DISTANCE;
		}

		int x = ((stars[i][0] * SCALE) / stars[i][2]) + WIDTH / 2;
		int y = ((stars[i][1] * SCALE) / stars[i][2]) + HEIGHT / 2;

		if (x >  0 && x < WIDTH && y > 0 && y < HEIGHT) {
			graphics->PutPixel(x, y, WHITE - (SHADE * stars[i][2]));
		}
	}
}
